part of YIM;

class _YIMListenerManager {
  _YIMListenerManager._internal();

  static final _ = _YIMListenerManager._internal();

  factory _YIMListenerManager() {
    if (_YIMSDK.option == null) _YIMSDK.utils.yimLog("${_.runtimeType}:Please init First!");
    return _;
  }

  void Function(List<YIMMessage>)? _callback_message;
  void Function(_YIMBroadcastMessage)? _callback_broadcast;
  void Function(_YIMNotificationMessage)? _callback_notification;
  void Function(YIMRevokeMessage)? _callback_revoke;
  void Function()? _callback_recentConversation;
  void Function(_YIMResult<YIMEnum_OnlineState>)? _callback_status_online;
  void Function(String)? _callback_status_msg_receipt;

  void register_message({required void Function(List<YIMMessage> messages) callback}) => this._callback_message = callback;

  void unRegister_message() => _callback_message = null;

  void register_broadcast({required void Function(_YIMBroadcastMessage message) callback}) => this._callback_broadcast = callback;

  void unRegister_broadcast() => _callback_broadcast = null;

  void register_notification({required void Function(_YIMNotificationMessage message) callback}) => this._callback_notification = callback;

  void unRegister_notification() => _callback_notification = null;

  void register_revoke({required void Function(YIMRevokeMessage message) callback}) => this._callback_revoke = callback;

  void unRegister_revoke() => _callback_revoke = null;

  void register_recentConversation({required void Function() callback}) => this._callback_recentConversation = callback;

  void unRegister_recentConversation() => _callback_recentConversation = null;

  void register_status_online({required void Function(_YIMResult<YIMEnum_OnlineState> result) callback}) => this._callback_status_online = callback;

  void unRegister_status_online() => _callback_status_online = null;

  void register_status_msg_receipt({required void Function(String conversationID) callback}) => this._callback_status_msg_receipt = callback;

  void unRegister_status_msg_receipt() => _callback_status_msg_receipt = null;
}
