part of YIM;

class _YIMTeamManager {
  _YIMTeamManager._internal();

  static final _ = _YIMTeamManager._internal();

  factory _YIMTeamManager() {
    if (_YIMSDK.option == null) _YIMSDK.utils.yimLog("${_.runtimeType}:Please init First!");
    return _;
  }

  void queryInfo({required String teamID, required void Function(bool isSuccess, _YIMTeam? team) callback}) {
    if (!YIM.userManager.isLogin()) {
      try {
        callback.call(false, null);
      } catch (e) {}
      return;
    }
    _YIMSDK.server.emit("queryTeamInfo", data: {
      "teamID": teamID,
    }, ack: (isSuccess, results, code, msg) {
      if (!isSuccess) {
        try {
          callback.call(false, null);
        } catch (e) {}
        return;
      }
      try {
        callback.call(true, _YIMTeam.fromJson(json.decode(results!["team"])));
      } catch (e) {}
    });
  }
}
